/*
 * Included:
 * CryptoJS/sha256.js
 * CryptoJS/enc-base64-min.js
 * login.js
 */

var CryptoJS=CryptoJS||function(a,b){var c={},d=c.lib={},e=d.Base=function(){function a(){}return{extend:function(b){a.prototype=this;var c=new a();b&&c.mixIn(b);c.$super=this;return c;},create:function(){var a=this.extend();a.init.apply(a,arguments);return a;},init:function(){},mixIn:function(a){for(var b in a)a.hasOwnProperty(b)&&(this[b]=a[b]);a.hasOwnProperty("toString")&&(this.toString=a.toString);},clone:function(){return this.$super.extend(this);}};}(),f=d.WordArray=e.extend({init:function(a,c){a=this.words=a||[];this.sigBytes=c!=b?c:4*a.length;},toString:function(a){return(a||h).stringify(this);},concat:function(a){var b=this.words,c=a.words,d=this.sigBytes,a=a.sigBytes;this.clamp();if(d%4)for(var e=0;e<a;e++)b[d+e>>>2]|=(c[e>>>2]>>>24-8*(e%4)&255)<<24-8*((d+e)%4);else if(65535<c.length)for(e=0;e<a;e+=4)b[d+e>>>2]=c[e>>>2];else b.push.apply(b,c);this.sigBytes+=a;return this;},clamp:function(){var b=this.words,c=this.sigBytes;b[c>>>2]&=4294967295<<32-8*(c%4);b.length=a.ceil(c/4);},clone:function(){var a=e.clone.call(this);a.words=this.words.slice(0);return a;},random:function(b){for(var c=[],d=0;d<b;d+=4)c.push(4294967296*a.random()|0);return f.create(c,b);}}),g=c.enc={},h=g.Hex={stringify:function(a){for(var b=a.words,a=a.sigBytes,c=[],d=0;d<a;d++){var e=b[d>>>2]>>>24-8*(d%4)&255;c.push((e>>>4).toString(16));c.push((e&15).toString(16));}return c.join("");},parse:function(a){for(var b=a.length,c=[],d=0;d<b;d+=2)c[d>>>3]|=parseInt(a.substr(d,2),16)<<24-4*(d%8);return f.create(c,b/2);}},i=g.Latin1={stringify:function(a){for(var b=a.words,a=a.sigBytes,c=[],d=0;d<a;d++)c.push(String.fromCharCode(b[d>>>2]>>>24-8*(d%4)&255));return c.join("");},parse:function(a){for(var b=a.length,c=[],d=0;d<b;d++)c[d>>>2]|=(a.charCodeAt(d)&255)<<24-8*(d%4);return f.create(c,b);}},j=g.Utf8={stringify:function(a){try{return decodeURIComponent(escape(i.stringify(a)));}catch(b){throw Error("Malformed UTF-8 data");}},parse:function(a){return i.parse(unescape(encodeURIComponent(a)));}},k=d.BufferedBlockAlgorithm=e.extend({reset:function(){this._data=f.create();this._nDataBytes=0;},_append:function(a){"string"==typeof a&&(a=j.parse(a));this._data.concat(a);this._nDataBytes+=a.sigBytes;},_process:function(b){var c=this._data,d=c.words,e=c.sigBytes,g=this.blockSize,h=e/(4*g),h=b?a.ceil(h):a.max((h|0)-this._minBufferSize,0),b=h*g,e=a.min(4*b,e);if(b){for(var i=0;i<b;i+=g)this._doProcessBlock(d,i);i=d.splice(0,b);c.sigBytes-=e;}return f.create(i,e);},clone:function(){var a=e.clone.call(this);a._data=this._data.clone();return a;},_minBufferSize:0});d.Hasher=k.extend({init:function(){this.reset();},reset:function(){k.reset.call(this);this._doReset();},update:function(a){this._append(a);this._process();return this;},finalize:function(a){a&&this._append(a);this._doFinalize();return this._hash;},clone:function(){var a=k.clone.call(this);a._hash=this._hash.clone();return a;},blockSize:16,_createHelper:function(a){return function(b,c){return a.create(c).finalize(b);};},_createHmacHelper:function(a){return function(b,c){return l.HMAC.create(a,c).finalize(b);};}});var l=c.algo={};return c;}(Math);(function(a){var b=CryptoJS,c=b.lib,d=c.WordArray,c=c.Hasher,e=b.algo,f=[],g=[];(function(){function b(b){for(var c=a.sqrt(b),d=2;d<=c;d++)if(!(b%d))return !1;return !0;}function c(a){return 4294967296*(a-(a|0))|0;}for(var d=2,e=0;64>e;)b(d)&&(8>e&&(f[e]=c(a.pow(d,0.5))),g[e]=c(a.pow(d,1/3)),e++),d++;})();var h=[],e=e.SHA256=c.extend({_doReset:function(){this._hash=d.create(f.slice(0));},_doProcessBlock:function(a,b){for(var c=this._hash.words,d=c[0],e=c[1],f=c[2],i=c[3],j=c[4],k=c[5],l=c[6],m=c[7],n=0;64>n;n++){if(16>n)h[n]=a[b+n]|0;else{var o=h[n-15],p=h[n-2];h[n]=((o<<25|o>>>7)^(o<<14|o>>>18)^o>>>3)+h[n-7]+((p<<15|p>>>17)^(p<<13|p>>>19)^p>>>10)+h[n-16];}o=m+((j<<26|j>>>6)^(j<<21|j>>>11)^(j<<7|j>>>25))+(j&k^~j&l)+g[n]+h[n];p=((d<<30|d>>>2)^(d<<19|d>>>13)^(d<<10|d>>>22))+(d&e^d&f^e&f);m=l;l=k;k=j;j=i+o|0;i=f;f=e;e=d;d=o+p|0;}c[0]=c[0]+d|0;c[1]=c[1]+e|0;c[2]=c[2]+f|0;c[3]=c[3]+i|0;c[4]=c[4]+j|0;c[5]=c[5]+k|0;c[6]=c[6]+l|0;c[7]=c[7]+m|0;},_doFinalize:function(){var a=this._data,b=a.words,c=8*this._nDataBytes,d=8*a.sigBytes;b[d>>>5]|=128<<24-d%32;b[(d+64>>>9<<4)+15]=c;a.sigBytes=4*b.length;this._process();}});b.SHA256=c._createHelper(e);b.HmacSHA256=c._createHmacHelper(e);})(Math);(function(){var a=CryptoJS,b=a.lib.WordArray;a.enc.Base64={stringify:function(a){var b=a.words,c=a.sigBytes,d=this._map;a.clamp();for(var a=[],e=0;e<c;e+=3)for(var f=(b[e>>>2]>>>24-8*(e%4)&255)<<16|(b[e+1>>>2]>>>24-8*((e+1)%4)&255)<<8|b[e+2>>>2]>>>24-8*((e+2)%4)&255,g=0;4>g&&e+0.75*g<c;g++)a.push(d.charAt(f>>>6*(3-g)&63));if(b=d.charAt(64))for(;a.length%4;)a.push(b);return a.join("");},parse:function(a){var c=a.length,d=this._map,e=d.charAt(64);e&&(e=a.indexOf(e),-1!=e&&(c=e));for(var e=[],f=0,g=0;g<c;g++)if(g%4){var h=d.indexOf(a.charAt(g-1))<<2*(g%4),i=d.indexOf(a.charAt(g))>>>6-2*(g%4);e[f>>>2]|=(h|i)<<24-8*(f%4);f++;}return b.create(e,f);},_map:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="};})();$(document).ready(function(){$("#login_form").submit(function(a){var b=hashPassword($("#password_input").val());var c=$("<input />").attr("type","hidden").attr("name","password").val(b);$("#login_form").append(c);});});function getToken(){return Math.floor((new Date().getTime()/1000)/120);}function getPermSalt(){return $("#permanent_salt").val();}function genSalt(){var a=new String();for(i=0;i<10;i++){var b=Math.floor(Math.random()*128);a+=String.fromCharCode(b);}return window.btoa(a);}function hashPassword(a){var b=genSalt();var c=getToken();var d=CryptoJS.SHA256(c+b);var e=CryptoJS.SHA256(a);var f=CryptoJS.SHA256(e+getPermSalt());var g=CryptoJS.SHA256(f+d);return "$"+b+"$"+g;}function computeHP(a){var b=genSalt();var c=CryptoJS.SHA256(a);var d=CryptoJS.SHA256(c+getPermSalt());var e=CryptoJS.SHA256(d+b);return new Array(b,e);}function computeSession(a){var b=computeHP(a);sessionStorage.persistentSession="$"+b[0]+"$"+b[1];}function getSession(){if(sessionStorage.persistentSession)var a=sessionStorage.persistentSession.split("$").slice(1);else var a=new Array("","");var b=getToken();var c=CryptoJS.SHA256(b+a[0]);var d=CryptoJS.SHA256(a[1]+c);return "$"+a[0]+"$"+d;}
